package com.supwisdom.dlpay.system.service;

import com.supwisdom.dlpay.api.bean.JsonResult;
import com.supwisdom.dlpay.framework.domain.TFunction;
import com.supwisdom.dlpay.framework.domain.TResource;
import com.supwisdom.dlpay.framework.util.PageResult;
import com.supwisdom.dlpay.system.bean.FunctionSearchBean;

import java.util.List;
import java.util.Map;

public interface FunctionService {
  List<TFunction> getFunctionsByOperid(String operid);

  List<Map<String, Object>> getMenuTree(List<TFunction> funcList, Integer parentId);

  PageResult<TFunction> getFunctionsByKey(FunctionSearchBean param);

  TFunction getFunctionByNameAndId(String name,Integer id);

  JsonResult saveFunction(TFunction function);

  TFunction getFunctionById(Integer id);

  JsonResult deleteFunction(Integer funcid);

  List<TFunction> getParentFunction();

  List<TResource> getResources(Integer function);

  List<TFunction> getLeafFunction();

  JsonResult saveRes(TResource resource);

  JsonResult deleteResource(Integer resid);
}
